

# GetInstanceMetricData


Returns the data points for the specified Amazon Lightsail instance metric, given an instance name.

Metrics report the utilization of your resources, and the error counts generated by them. Monitor and collect metric data regularly to maintain the reliability, availability, and performance of your resources.

## Request Syntax


```
{
   "endTime": number,
   "instanceName": "string",
   "metricName": "string",
   "period": number,
   "startTime": number,
   "statistics": [ "string" ],
   "unit": "string"
}
```

## Request Parameters


For information about the parameters that are common to all actions, see [Common Parameters](CommonParameters.md).

The request accepts the following data in JSON format.

 ** [endTime](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-endTime"></a>
The end time of the time period.  
Type: Timestamp  
Required: Yes

 ** [instanceName](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-instanceName"></a>
The name of the instance for which you want to get metrics data.  
Type: String  
Pattern: `\w[\w\-]*\w`   
Required: Yes

 ** [metricName](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-metricName"></a>
The metric for which you want to return information.  
Valid instance metric names are listed below, along with the most useful `statistics` to include in your request, and the published `unit` value.  
+  ** `BurstCapacityPercentage` ** - The percentage of CPU performance available for your instance to burst above its baseline. Your instance continuously accrues and consumes burst capacity. Burst capacity stops accruing when your instance's `BurstCapacityPercentage` reaches 100%. For more information, see [Viewing instance burst capacity in Amazon Lightsail](https://docs.aws.amazon.com/lightsail/latest/userguide/amazon-lightsail-viewing-instance-burst-capacity).

   `Statistics`: The most useful statistics are `Maximum` and `Average`.

   `Unit`: The published unit is `Percent`.
+  ** `BurstCapacityTime` ** - The available amount of time for your instance to burst at 100% CPU utilization. Your instance continuously accrues and consumes burst capacity. Burst capacity time stops accruing when your instance's `BurstCapacityPercentage` metric reaches 100%.

  Burst capacity time is consumed at the full rate only when your instance operates at 100% CPU utilization. For example, if your instance operates at 50% CPU utilization in the burstable zone for a 5-minute period, then it consumes CPU burst capacity minutes at a 50% rate in that period. Your instance consumed 2 minutes and 30 seconds of CPU burst capacity minutes in the 5-minute period. For more information, see [Viewing instance burst capacity in Amazon Lightsail](https://docs.aws.amazon.com/lightsail/latest/userguide/amazon-lightsail-viewing-instance-burst-capacity).

   `Statistics`: The most useful statistics are `Maximum` and `Average`.

   `Unit`: The published unit is `Seconds`.
+  ** `CPUUtilization` ** - The percentage of allocated compute units that are currently in use on the instance. This metric identifies the processing power to run the applications on the instance. Tools in your operating system can show a lower percentage than Lightsail when the instance is not allocated a full processor core.

   `Statistics`: The most useful statistics are `Maximum` and `Average`.

   `Unit`: The published unit is `Percent`.
+  ** `NetworkIn` ** - The number of bytes received on all network interfaces by the instance. This metric identifies the volume of incoming network traffic to the instance. The number reported is the number of bytes received during the period. Because this metric is reported in 5-minute intervals, divide the reported number by 300 to find Bytes/second.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Bytes`.
+  ** `NetworkOut` ** - The number of bytes sent out on all network interfaces by the instance. This metric identifies the volume of outgoing network traffic from the instance. The number reported is the number of bytes sent during the period. Because this metric is reported in 5-minute intervals, divide the reported number by 300 to find Bytes/second.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Bytes`.
+  ** `StatusCheckFailed` ** - Reports whether the instance passed or failed both the instance status check and the system status check. This metric can be either 0 (passed) or 1 (failed). This metric data is available in 1-minute (60 seconds) granularity.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Count`.
+  ** `StatusCheckFailed_Instance` ** - Reports whether the instance passed or failed the instance status check. This metric can be either 0 (passed) or 1 (failed). This metric data is available in 1-minute (60 seconds) granularity.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Count`.
+  ** `StatusCheckFailed_System` ** - Reports whether the instance passed or failed the system status check. This metric can be either 0 (passed) or 1 (failed). This metric data is available in 1-minute (60 seconds) granularity.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Count`.
+  ** `MetadataNoToken` ** - Reports the number of times that the instance metadata service was successfully accessed without a token. This metric determines if there are any processes accessing instance metadata by using Instance Metadata Service Version 1, which doesn't use a token. If all requests use token-backed sessions, such as Instance Metadata Service Version 2, then the value is 0.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Count`.
Type: String  
Valid Values: `CPUUtilization | NetworkIn | NetworkOut | StatusCheckFailed | StatusCheckFailed_Instance | StatusCheckFailed_System | BurstCapacityTime | BurstCapacityPercentage | MetadataNoToken`   
Required: Yes

 ** [period](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-period"></a>
The granularity, in seconds, of the returned data points.  
The `StatusCheckFailed`, `StatusCheckFailed_Instance`, and `StatusCheckFailed_System` instance metric data is available in 1-minute (60 seconds) granularity. All other instance metric data is available in 5-minute (300 seconds) granularity.  
Type: Integer  
Valid Range: Minimum value of 60. Maximum value of 86400.  
Required: Yes

 ** [startTime](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-startTime"></a>
The start time of the time period.  
Type: Timestamp  
Required: Yes

 ** [statistics](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-statistics"></a>
The statistic for the metric.  
The following statistics are available:  
+  `Minimum` - The lowest value observed during the specified period. Use this value to determine low volumes of activity for your application.
+  `Maximum` - The highest value observed during the specified period. Use this value to determine high volumes of activity for your application.
+  `Sum` - All values submitted for the matching metric added together. You can use this statistic to determine the total volume of a metric.
+  `Average` - The value of Sum / SampleCount during the specified period. By comparing this statistic with the Minimum and Maximum values, you can determine the full scope of a metric and how close the average use is to the Minimum and Maximum values. This comparison helps you to know when to increase or decrease your resources.
+  `SampleCount` - The count, or number, of data points used for the statistical calculation.
Type: Array of strings  
Valid Values: `Minimum | Maximum | Sum | Average | SampleCount`   
Required: Yes

 ** [unit](#API_GetInstanceMetricData_RequestSyntax) **   <a name="Lightsail-GetInstanceMetricData-request-unit"></a>
The unit for the metric data request. Valid units depend on the metric data being requested. For the valid units to specify with each available metric, see the `metricName` parameter.  
Type: String  
Valid Values: `Seconds | Microseconds | Milliseconds | Bytes | Kilobytes | Megabytes | Gigabytes | Terabytes | Bits | Kilobits | Megabits | Gigabits | Terabits | Percent | Count | Bytes/Second | Kilobytes/Second | Megabytes/Second | Gigabytes/Second | Terabytes/Second | Bits/Second | Kilobits/Second | Megabits/Second | Gigabits/Second | Terabits/Second | Count/Second | None`   
Required: Yes

## Response Syntax


```
{
   "metricData": [ 
      { 
         "average": number,
         "maximum": number,
         "minimum": number,
         "sampleCount": number,
         "sum": number,
         "timestamp": number,
         "unit": "string"
      }
   ],
   "metricName": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [metricData](#API_GetInstanceMetricData_ResponseSyntax) **   <a name="Lightsail-GetInstanceMetricData-response-metricData"></a>
An array of objects that describe the metric data returned.  
Type: Array of [MetricDatapoint](API_MetricDatapoint.md) objects

 ** [metricName](#API_GetInstanceMetricData_ResponseSyntax) **   <a name="Lightsail-GetInstanceMetricData-response-metricName"></a>
The name of the metric returned.  
Type: String  
Valid Values: `CPUUtilization | NetworkIn | NetworkOut | StatusCheckFailed | StatusCheckFailed_Instance | StatusCheckFailed_System | BurstCapacityTime | BurstCapacityPercentage | MetadataNoToken` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Lightsail throws this exception when the user cannot be authenticated or uses invalid credentials to access a resource.  
HTTP Status Code: 400

 ** AccountSetupInProgressException **   
Lightsail throws this exception when an account is still in the setup in progress state.  
HTTP Status Code: 400

 ** InvalidInputException **   
Lightsail throws this exception when user input does not conform to the validation rules of an input field.  
Domain and distribution APIs are only available in the N. Virginia (`us-east-1`) AWS Region. Please set your AWS Region configuration to `us-east-1` to create, view, or edit these resources.
HTTP Status Code: 400

 ** NotFoundException **   
Lightsail throws this exception when it cannot find a resource.  
HTTP Status Code: 400

 ** OperationFailureException **   
Lightsail throws this exception when an operation fails to execute.  
HTTP Status Code: 400

 ** RegionSetupInProgressException **   
Lightsail throws this exception when an operation is performed on resources in an opt-in Region that is currently being set up.    
 ** docs **   
 [Regions and Availability Zones for Lightsail](https://docs.aws.amazon.com/lightsail/latest/userguide/understanding-regions-and-availability-zones-in-amazon-lightsail.html)   
 ** tip **   
Opt-in Regions typically take a few minutes to finish setting up before you can work with them. Wait a few minutes and try again.
HTTP Status Code: 400

 ** ServiceException **   
A general service exception.  
HTTP Status Code: 500

 ** UnauthenticatedException **   
Lightsail throws this exception when the user has not been authenticated.  
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/lightsail-2016-11-28/GetInstanceMetricData) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/lightsail-2016-11-28/GetInstanceMetricData) 